
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Workflow_stepsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        code: data.code
        ||
        null
            ,
            
        step_order: data.step_order
        ||
        null
            ,
            
        step_type: data.step_type
        ||
        null
            ,
            
        is_blocking: data.is_blocking
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await workflow_steps.setWorkflow_definition( data.workflow_definition || null, {
            transaction,
        });
        
        await workflow_steps.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return workflow_steps;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const workflow_stepsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                code: item.code
            ||
            null
            ,
            
                step_order: item.step_order
            ||
            null
            ,
            
                step_type: item.step_type
            ||
            null
            ,
            
                is_blocking: item.is_blocking
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const workflow_steps = await db.workflow_steps.bulkCreate(workflow_stepsData, { transaction });

        // For each item created, replace relation files
        

        return workflow_steps;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const workflow_steps = await db.workflow_steps.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.step_order !== undefined) updatePayload.step_order = data.step_order;
        
        
        if (data.step_type !== undefined) updatePayload.step_type = data.step_type;
        
        
        if (data.is_blocking !== undefined) updatePayload.is_blocking = data.is_blocking;
        
        
        updatePayload.updatedById = currentUser.id;

        await workflow_steps.update(updatePayload, {transaction});

        
        
        if (data.workflow_definition !== undefined) {
            await workflow_steps.setWorkflow_definition(
              
              data.workflow_definition,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await workflow_steps.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return workflow_steps;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of workflow_steps) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of workflow_steps) {
                await record.destroy({transaction});
            }
        });


        return workflow_steps;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.findByPk(id, options);

        await workflow_steps.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await workflow_steps.destroy({
            transaction
        });

        return workflow_steps;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.findOne(
            { where },
            { transaction },
        );

        if (!workflow_steps) {
            return workflow_steps;
        }

        const output = workflow_steps.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workflow_definition = await workflow_steps.getWorkflow_definition({
            transaction
        });
        
        
        output.organizations = await workflow_steps.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workflow_definitions,
        as: 'workflow_definition',
        
        where: filter.workflow_definition ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workflow_definition.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workflow_definition.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'workflow_steps',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'workflow_steps',
                        'code',
                        filter.code,
                    ),
                };
            }
            

            
            

            
            if (filter.step_orderRange) {
                const [start, end] = filter.step_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    step_order: {
                    ...where.step_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    step_order: {
                    ...where.step_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.step_type) {
                where = {
                    ...where,
                step_type: filter.step_type,
            };
            }
            
            if (filter.is_blocking) {
                where = {
                    ...where,
                is_blocking: filter.is_blocking,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.workflow_steps.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'workflow_steps',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.workflow_steps.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

